require 'redmine'
require 'dispatcher'
require 'show_descriptions_patch'
require 'query_per_project_constants'

Dispatcher.to_prepare :redmine_default_columns_plus do
  require_dependency 'issues_controller'
  # Guards against including the module multiple time (like in tests)
  # and registering multiple callbacks  
  unless IssuesController.included_modules.include? ShowDescriptionsPatch::IssuesControllerPatch
    IssuesController.send(:include, ShowDescriptionsPatch::IssuesControllerPatch)
  end
end

unless Redmine::Plugin.registered_plugins.keys.include?(:redmine_default_columns)
  Redmine::Plugin.register :redmine_default_columns_plus do
    name 'Default queries per project plus'
    author 'Vitaly Klimov (Default columns) & Alexandr Poplavsky (show description) & Luis Serrano (integration and news)'
    description 'Plugin allows to apply default queries for individual project or for projects based on their type, show full issue descriptions in the issues list and permissions if do you want view in your role the options and the filters.'
    version '0.0.7'
  project_module :issue_tracking do
    permission :filter_issues_option, {:filter_issues_option => [:index, :show]}
    permission :options_issues_option, {:options_issues_option => [:index, :show]}
  end
    settings(:partial => 'settings/default_columns_settings',
             :default => {
               'query_templates_project_id' => '0',
               'type_custom_field_name' => QPP_Constants::TYPE_CUSTOM_FIELD_NAME,
               'default_query_name' => QPP_Constants::QUERY_DEFAULT_NAME,
               'my_default_query_name' => QPP_Constants::MY_QUERY_DEFAULT_NAME,
               'my_global_query_name' => QPP_Constants::MY_QUERY_GLOBAL_DEFAULT_NAME,
               'my_home_query_name' => QPP_Constants::MY_QUERY_HOME_NAME
             })

  requires_redmine :version_or_higher => '1.0.1'
  end
end

